using namespace std;
#include "DataPoints.h"
#include "Interpolator.h"
#include<math.h>
#include"TMultiGraph.h"
#include"TLegend.h"
int main()
{
    /*
    vector<double> tempo={0.71, 1.51, 2.31, 3.11, 3.91, 4.71, 5.51, 6.31, 7.11, 7.91, 8.71, 9.51};;
    vector<double> teta={0.607, -1.02, -1.22, 0.28, 1.39, 0.56, -1.05, -1.20, 0.33, 1.40, 0.51, -1.09};
    vector<double> velocidade={2, 1.52, -1.08, -2.17,-0.23,2.03,1.46, -1.15,-2.15,-0.15,2.06,1.39};
    */
    vector<double> tempo={0.71, 1.51, 2.31, 3.11, 3.91, 4.71, 5.51, 6.31, 7.11, 7.91, 8.71, 9.51};;
    vector<double> teta={0.806, -0.702, -1.395, -0.608, 0.889, 1.371, 0.391, -1.051, -1.314, -0.162, 1.183, 1.225};
    vector<double> velocidade={-1.594, -1.7, 0.065, 1.781,1.495,-0.347,-1.918,-1.259,0.626,1.996,1.001,-0.9};


    Interpolator I(tempo, teta);
    Interpolator V(tempo, velocidade);

   
    //usar a nossa friend function!!!!!!!!!
    cout << I;
    cout<< V;
  

    //TApplication app("app", nullptr, nullptr);
    TCanvas* c1 = new TCanvas("c1","Grafico",100,100,1800,1020);
    TF1* FuncS=I.GetFunction("Spline3");
    TF1* FuncSV=V.GetFunction("Spline3");
    TLegend* legend= new TLegend(0.43,0.7, 0.67, 0.9);
    TGraph* gr1=I.GetGraph();
    TGraph* gr2=V.GetGraph();
    TLegend* legend2= new TLegend(0.45,0.8, 0.55, 0.9);
    gr1->SetMarkerColor(kBlack);
    gr1->SetMarkerStyle(kFullCircle);
    gr2->SetMarkerColor(kBlue);
    gr2->SetMarkerStyle(kFullTriangleUp);
    FuncS->SetLineColor(kRed);
    FuncSV->SetLineColor(kGreen);
    TMultiGraph* MG=new TMultiGraph();
    MG->Add(gr1);
    MG->Add(gr2);
    MG->Draw("AP");
    MG->SetTitle("Using Spline3 Interpolation: Angular Position and Velocity of a Pendulum with L=4.0m, #theta_{0}=1.4(rad) and v_{0}=0(rad/s); Time[s]; Angle(#theta)[rad]//Angular Velocity(#omega)[rad/s]");
    MG->SetMinimum(-3.);
    MG->SetMaximum(3.);
    FuncS->Draw("Same");
    FuncSV->Draw("Same");
    legend->SetHeader("Legend", "C");
    legend->AddEntry(FuncS,"Interpolation of the angle");
    legend->AddEntry(FuncSV,"Interpolation of the angular velocity");
    legend->AddEntry(gr1,"Given angular positions");
    legend->AddEntry(gr2,"Given angular velocities");
    legend->Draw();
    c1->Modified();
    c1->Update();
    c1->SaveAs("Interpolation.png");
    //EM->Draw();
    //app.Run();
    //TCanvas* c2 = new TCanvas("c1","Energias",100,100,1800,1020);
    c1->Clear();
    TF1* EM=new TF1("Energia Mecanica", [&](Double_t* x, Double_t* par){return (9.8*2.*(1.-cos(FuncS->Eval(x[0])))+4.*(FuncSV->Eval(x[0]))*(FuncSV->Eval(x[0])));},1.0, 9.0,0);
    TF1* EC=new TF1("Energia Cinetica", [&](Double_t* x, Double_t* par){return (4.*(FuncSV->Eval(x[0]))*(FuncSV->Eval(x[0])));},1.0, 9.0,0);
    TF1* EP=new TF1("Energia Potencial", [&](Double_t* x, Double_t* par){return (9.8*2.*(1.-cos(FuncS->Eval(x[0]))));},1.0, 9.0,0);
    EM->SetLineColor(kRed);
    EM->SetMinimum(0.);
    EM->SetMaximum(20.);
    EC->SetLineColor(kBlue);
    EP->SetLineColor(kGreen);
    EM->Draw();
    EC->Draw("Same");
    EP->Draw("Same");
    legend2->SetHeader("Legend", "C");
    legend2->AddEntry(EM,"Mechanical Energy");
    legend2->AddEntry(EC,"Kinetic Energy");
    legend2->AddEntry(EP,"Potencial Energy");
    legend2->Draw();
    c1->Modified();
    c1->Update();
    c1->SaveAs("Grafico das energias.png");
    double Media;
    for(int i=1; i<16; ++i)
    {
        Media=Media+EM->Eval(1+i/2);
    }
    Media=Media/15;
    cout<<endl;
    cout<< "O valor da Energia Mecanica e aproximadamente: "<< Media<< " J" <<endl;
    cout<<endl;
    delete gr1, gr2, MG, FuncS, FuncSV, legend, c1, legend2;
    return 0;
}