#ifndef __DATAPOINTS__
#define __DATAPOINTS__

#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include "TCanvas.h"
#include "TGraph.h"
#include "TRootCanvas.h"
#include "TApplication.h"

class DataPoints
{
public:
    //Construtores
    DataPoints(int n=0, double *x=NULL, double *y=NULL); // build DataPoints from C-arrays of x and y values
    DataPoints(const std::vector<std::pair<double, double>> &);
    DataPoints(const std::vector<double> &x, const std::vector<double> &y);
    //Destrutor
    virtual ~DataPoints();

    //getters
    const std::vector<std::pair<double, double>> GetPoints();
    virtual TGraph *GetGraph();

    //draw points using ROOT object TGraph
    virtual void Draw();

    // friend functions (optional)
    friend std::ostream &operator<<(std::ostream &, const DataPoints &);

protected:
    std::vector<std::pair<double, double>> P;
};

#endif
