#ifndef __INTEGDERIVND__
#define __INTEGDERIVND__

#include "FunctorND.h"
#include <TRandom3.h>

class IntegDerivND
{
public:
    IntegDerivND(FunctorND &);
    ~IntegDerivND() = default;

    // integration methods (retornam o erro pela formula da truncaçao)
    void SimpsonRule(double &xi, double &xf, double &Integral, double &Error, int nintervals = 100);
    void SimpsonRuleND(double *xi, double *xf, double &Integral, double &Error, int nintervals = 100);

    // monte carlo integration methods
    void MonteCarlo(std::vector<double> xi, std::vector<double> xf, int ntrials, double &value, double &error);
    void MonteCarloImportanceSampling(double *xi, double *xf, int ntrials, double &value, double &error, std::function<double(double *)> px = 0, std::function<double(double *)> xy = 0);

private:
    FunctorND& FND;
};
#endif