#ifndef EQSOLVER
#define EQSOLVER
#include<iostream>
#include<eigen3/Eigen/Core>
#include<vector>
using namespace Eigen;
#include<cstdlib>
using namespace std;
#include<math.h>


class EqSolver{
public:
EqSolver(Matrix<double,Dynamic,Dynamic>& Coef, Matrix<double,Dynamic,1>& Cons);
EqSolver(const vector<double>& a, const vector<double>& d, const vector<double>& c, Matrix<double,Dynamic,1>& Cons); //For banded matrices

~EqSolver() = default;

void teste();

Matrix<double,Dynamic,1> GaussSolver(bool pivot);

const Matrix<double, Dynamic,1>& LUSolver ();

const Matrix<double, Dynamic, 1>& BandedSolver();

void IterativeJacobiSolver(Eigen::Matrix<double, Eigen::Dynamic, 1>& x, int itmax, double tol);

void IterativeGaussSeidelSolver(Eigen::Matrix<double, Eigen::Dynamic, 1> &x, int itmax, double tol);

 private:
    Matrix<double,Dynamic,Dynamic> M; // coefficients matrix
    Matrix<double,Dynamic,1> b; // constants vector
    vector<double> under; 
    vector<double> diagonal; 
    vector<double> upper;
    
};
#endif
