#include"FCMatrix.h"
#include<iostream>
#include<iomanip>
#include<vector>
#include<utility>
using namespace std;
using namespace Eigen;

void FCMatrixAlgo::GaussElimination( Matrix<double,Dynamic,Dynamic>& A, Matrix<double,Dynamic,1>& b)  {

    double lambda;
    int k, i, j, n;
    n=b.rows();

for(k=0; k<n; ++k) {    //Gaussada
    if(A(k,k)!=0){
       for(i = k+1; i<n; ++i){
                lambda= A(i,k)/A(k,k);
          
                A.row(i)= A.row(i) - lambda*A.row(k);
                b.row(i)= b.row(i) - lambda*b.row(k);
            }
        }    
    else for(i = k+1; i<n ; ++i){  //caso haja 0 no lugar do prox. pivot
        if (A(i,k)!=0){
            
            auto temp(A);
            auto temp2(b);

            A.row(i) = A.row(k);   //troca de linhas
            A.row(k)= temp.row(i); 
            b.row(i)=b.row(k);
            b.row(k)=temp2.row(i); 
            k=k-1; 

            
            break;
        }
    }
}
}

void FCMatrixAlgo::GaussEliminationPivot(Matrix<double, Dynamic, Dynamic> &A, Matrix<double, Dynamic, 1>& b, vector<int>& index)

{  
    double lambda;
    int k, i, j, n, m, pivot, temp;
    n = b.rows();
    m = A.cols();
    index.resize(n);
    double *s = new double[n];
    for(i=0; i<n; ++i) { index[i]=i;}
    for (k = 0; k < n-1; ++k)
    {

        for (i = k; i < n; ++i)
        { //coeficientes s;
            s[index[i]] = 0;
            for (j = 0; j < m; ++j)
            {
                if (s[index[i]] < A(index[i], j))
                s[index[i]] = A(index[i], j);
            }
        }

        double R = 0; pivot=index[k];
        for (i = k; i < n; ++i)   //choosing pivot
        {
            if (s[index[i]] != 0)
                if ((fabs(A(index[i], k)) / s[index[i]]) > R)
                {
                    R = fabs(A(index[i], k)) / s[index[i]];
                    pivot = index[i]; 
                }
        }
            
        
        {   if (R==0) break;                   //swapping rows
            //auto temp(A);
            //auto temp2(b);
            temp = index[k];
            index[k] = index[pivot];
            index[pivot] = temp;
            //A.row(k) = A.row(pivot);
            //A.row(pivot) = temp.row(k);
            //b.row(k) = b.row(pivot);
            //b.row(pivot) = temp2.row(k);
        }
            
        for (i = k + 1; i < n; ++i)  //gaussada
        {
            lambda = A(index[i], k) / A(index[k], k);

            A.row(index[i]) = A.row(index[i]) - lambda * A.row(index[k]);
            b.row(index[i]) = b.row(index[i]) - lambda * b.row(index[k]);
        }
    }
}

/*
void FCMatrixAlgo::GaussEliminationPivot(Matrix<double, Dynamic, Dynamic> &A, Matrix<double, Dynamic, 1>& b)

{
    double lambda;
    int k, i, j, n, m, pivot;
    n = b.rows();
    m = A.cols();
    double *s = new double[n];
    for (k = 0; k < n; ++k)
    {

        for (i = k; i < n; ++i)
        { //coeficientes s;
            s[i] = 0;
            for (j = 0; j < m; ++j)
            {
                if (s[i] < A(i, j))
                s[i] = A(i, j);
            }
        }

        double R = 0; pivot=k;
        for (i = k; i < n; ++i)   //choosing pivot
        {
            if (s[i] != 0)
                if ((fabs(A(i, k)) / s[i]) > R)
                {
                    R = fabs(A(i, k)) / s[i];
                    pivot = i;
                }
        }

        
        {   if (R==0) break;                   //swapping rows
            auto temp(A);
            auto temp2(b);

            A.row(k) = A.row(pivot);
            A.row(pivot) = temp.row(k);
            b.row(k) = b.row(pivot);
            b.row(pivot) = temp2.row(k);
        }

        for (i = k + 1; i < n; ++i)  //gaussada
        {
            lambda = A(i, k) / A(k, k);

            A.row(i) = A.row(i) - lambda * A.row(k);
            b.row(i) = b.row(i) - lambda * b.row(k);
        }
    }
}*/


 pair<Matrix<double,Dynamic,Dynamic>, Matrix<double,Dynamic,Dynamic>> FCMatrixAlgo::LUDoolittle(Matrix<double,Dynamic,Dynamic>& A){

    pair<Matrix<double,Dynamic,Dynamic>, Matrix<double,Dynamic,Dynamic>> Decomp;
    Matrix<double,Dynamic,Dynamic> L;
    Matrix<double,Dynamic,Dynamic> U;
    int n = A.rows();
    L.resize(n, n);
    U.resize(n, n);

for (int i = 0; i < n; i++)
    {
        // U Triangular
        for (int k = i; k < n; k++)
        {
            // Summation of L(i, j) * U(j, k)
            double sum = 0.;
            for (int j = 0; j < i; j++)
                sum += (L(i,j) * U(j,k));
 
            // Evaluating U(i, k)
            U(i,k) = A(i,k) - sum;
        }
 
        // L Triangular
        for (int k = i; k < n; k++)
        {
            if (i == k)
                L(i,i) = 1; // Diagonal as 1
            else
            {
                // Summation of L(k, j) * U(j, i)
                double sum = 0.;
                for (int j = 0; j < i; j++)
                    sum += (L(k,j) * U(j, i));
 
                // Evaluating L(k, i)
                L(k,i) = (A(k,i) - sum) / U(i,i);
            }
        }
    }
 
    /*// setw is for displaying nicely
    cout << setw(6)
         << "      L Triangular"
         << setw(32)
         << "U Triangular" << endl;
 
    // Displaying the result :
    for (int i = 0; i < n; i++)
    {
        // L
        for (int j = 0; j < n; j++)
            cout << setw(6) << L(i,j) << "\t";
        cout << "\t";
 
        // U
        for (int j = 0; j < n; j++)
            cout << setw(6) << U(i,j) << "\t";
        cout << endl;
    }*/




    Decomp.first = L;
    Decomp.second = U;

    return Decomp;

    
    
 }



