#ifndef FCMATRIX
#define FCMATRIX


#include<eigen3/Eigen/Core>
using namespace Eigen;
#include<cstdlib>
using namespace std;
#include<math.h>
#include<vector>


class FCMatrixAlgo {
    public:
    FCMatrixAlgo() = default;
    ~FCMatrixAlgo() = default;

    static void GaussElimination( Matrix<double,Dynamic,Dynamic>& A, Matrix<double,Dynamic,1>& b);

    static void GaussEliminationPivot(Matrix<double, Dynamic, Dynamic> &A, Matrix<double, Dynamic, 1> &b, vector<int>& index);

    static void LUdecompositionPivot(Matrix<double,Dynamic,Dynamic>& A, Matrix<double,Dynamic,1>& b);

    pair<Matrix<double,Dynamic,Dynamic>, Matrix<double,Dynamic,Dynamic>> LUDoolittle(Matrix<double,Dynamic,Dynamic>& A);

};

#endif
