#include "FunctorND.h"

double FunctorND::operator()(double *x) { return 0; }                       //Define the standard operator()
TCanvas* FunctorND::cn(new TCanvas("cn", "Graphs from FunctorND", 100, 100, 1820, 1020)); //Inicialize the Canvas

void FunctorND::Draw(std::vector<double> xi, std::vector<double> xf, std::vector<std::string> axis)
{
    auto l = [this](double *x, double *par)
    {
        return this->operator()(x); //Define lambda function for TF1
    };
    //Convert strings to the C array
    const char *Titulo = name.c_str();
    const char *xtit = axis[0].c_str();
    const char *ytit = axis[1].c_str();
    if (n == 1)
    {
        //Creation of TF1
        TF1 *F = new TF1("F", l, xi[0], xf[0], 0);
        //Settings for the function
        F->SetTitle(Titulo);
        F->GetYaxis()->SetTitle(ytit);
        F->GetXaxis()->SetTitle(xtit);
        F->SetLineColor(kBlue);
        F->Draw();
        cn->Modified();
        cn->Update();
        //Save the file with the function
        string name2 = name;
        name2 += ".png";
        const char *save = name2.c_str();
        cn->SaveAs(save);
        cn->Clear();
        delete F;
    }
    else if (n == 2)
    {
        const char *ztit = axis[2].c_str();
        //Creation of TF2
        TF2 *F = new TF2("F", l, xi[0], xf[0], xi[1], xf[1], 0);
        //Settings for the function
        F->SetTitle(Titulo);
        F->GetYaxis()->SetTitle(ytit);
        F->GetXaxis()->SetTitle(xtit);
        F->GetZaxis()->SetTitle(ztit);
        //com os seguintes dois ficas as cores
        //gStyle->SetPalette(kRainBow);
        //F->Draw("Surf2z");
        F->Draw("Surf"); //com este apenas fica com umas linhas
        cn->Modified();
        cn->Update();
        //Save the file with the function
        string name2 = name;
        name2 += ".png";
        const char *save = name2.c_str();
        cn->SaveAs(save);
        cn->Clear();
        delete F;
    }
    else
    {
        std::cout << "-------------------------------------------------------------------------" << std::endl;
        std::cout << "\tThere is no graph to draw, as this function has " << n << " dimensions.\n\tSo it's graph would have to be in " << n + 1 << " dimensions!" << std::endl;
        std::cout << "-------------------------------------------------------------------------" << std::endl;
    }
}