#ifndef __FUNCTORND__
#define __FUNCTORND__

#include <string>
#include <vector>
using namespace std;
#include "TCanvas.h"
#include "TF1.h"
#include "TF2.h"
#include "TAxis.h"
#include "TStyle.h"
#include <cmath>

class FunctorND
{
public:
    FunctorND(std::string s="FunctorND", int m=1) : name(s), n(m) { ; } //Constructor 
    virtual ~FunctorND() = default; //Default destructor

    int GetDimension(){return n;}
    virtual double operator()(double* x);

    virtual void Draw(std::vector<double> xi, std::vector<double> xf, std::vector<std::string> axis={"","",""});//Function to draw the function graph
       

protected:
    static TCanvas *cn;//Shared Canvas to draw
    std::string name;//Name of function
    int n;//Dimension of function
};

#endif