#include "line2D.h"
#include <iostream>
using namespace std;

line2D::line2D(Point2D P1, Point2D P2) : center((P1.GetX() + P2.GetX()) / 2, (P1.GetY() + P2.GetY()) / 2)
{
    vP.push_back(P1);
    vP.push_back(P2);
    double adjacente = center.GetX() - P1.GetX();
    double oposto = center.GetY() - P1.GetY();
    theta = atan(oposto / adjacente);
    if (adjacente == 0)
        theta = 0;
}

line2D::line2D(Point2D P1, double length, double ftheta) : center(P1), theta(ftheta)
{
    vP.push_back(Point2D(P1.GetX() - length / 2 * cos(theta), P1.GetY() - length / 2 * sin(theta)));
    vP.push_back(Point2D(P1.GetX() + length / 2 * cos(theta), P1.GetY() + length / 2 * sin(theta)));
}
line2D::~line2D()
{
    vP.clear();
}

Point2D& line2D::Vertices(bool n){
    return vP[n];
}
void line2D::SetLine(Point2D P1, double length, double ftheta)
{
    center = P1;
    theta = ftheta;
    vP.clear();
    vP.push_back(Point2D(P1.GetX() - length / 2 * cos(theta), P1.GetY() - length / 2 * sin(theta)));
    vP.push_back(Point2D(P1.GetX() + length / 2 * cos(theta), P1.GetY() + length / 2 * sin(theta)));
}

bool line2D::Crossing(line2D &L2)
{
    double m1 = tan(theta), m2 = tan(L2.theta);
    double b1 = center.GetY() - m1 * center.GetX(), b2 = L2.center.GetY() - m2 * L2.center.GetX();
    if (theta == L2.theta)
    {
        if (b1 == b2)
            return 1;
        else
            return 0;
    }
    else
    {
        double x, y;
        x = (b2 - b1) / (m1 - m2);
        y = m1 * x + b1;
        Point2D A(x, y);
        if (center.distance(A) <= center.distance(vP[0]))
            return 1;
        return 0;
    }
}