#include "shooting_meth.h"
#include "Roots.h"

ODEBoundary::ODEBoundary(const int n, std::vector<std::function<double(ODEpoint &)>> &F, 
            double tmax, int i, pair<int, double> & p,  Xvar &b): Ndim(n), index(i), f(F), tf(tmax), boundary(p), initial(b)
            {;}

double ODEBoundary::Minimizer(double x)
{
    Xvar X(initial);
    X[index]=x;
    ODESolver function(Ndim, X, f, 0); 
    std::vector<ODEpoint> sol = function.RungeKutta4(0.001, tf);
    int j = sol.size();
    return sol[j-1][boundary.first] - boundary.second;    
}   

double ODEBoundary::ShootingMethod(double xi, double xf){

    auto F = [this](double x)
    {
        return this->ODEBoundary::Minimizer(x);
        //return sol[j-1][boundary.first] - boundary.second;
    };

	MyFunction Shots("Shooter", F);
	RootSolver FindDeriv(Shots);
    return FindDeriv.Newton(xi, xf).first;
}
